//+------------------------------------------------------------------+
//|                                                 Debug.mq4 |
//|                                            Mark Flexhaug |
//|                                     pipaholic@shaw.ca|
//
// Sample Code in proggie to debug
//
//    if(debug)
//   {   
//       iCustom(0,0,"Debug","hello "+DoubleToStr(Bid,Digits),0,200,White,1,0);      
//   }
//
// REVISIONS
// Apr 30/07   - added log file capability
//+------------------------------------------------------------------+
#property copyright "Mark Flexhaug"
#property link      "pipaholic@shaw.ca"

#property indicator_chart_window
#define  Height   40

string   ShortName   = "Debug";

extern   string   Info;
extern   int      ColNum,
                  xStart;
                  
extern   color    FontColor   = Gold;
extern string     Name        = " ";
extern int        Tabs        = 0;


bool  UseDebug = false,
      Reset    = false,
      Dsound   = false;
               
int   Dperiod  = 0,
      UseLog,
      WindowHeight   = Height,
      FontSize       = 8;
      
string   Font  = "Arial Bold";

string   DebugData[Height] =  {  " "," "," "," ", " ", 
                                 " "," "," ", " ", " ",
                                 " "," "," ", " ", " ",
                                 " "," "," ", " ", " ",
                                 " "," "," ", " ", " ",
                                 " "," "," ", " ", " ",
                                 " "," "," ", " ", " ",
                                 " "," "," ", " ", " ",                                                                                                                                                                                                                                                                                                                                                              
                              };

color    DataColor[Height] =  {  Black,Black,Black,Black,Black,
                                 Black,Black,Black,Black,Black,
                                 Black,Black,Black,Black,Black,
                                 Black,Black,Black,Black,Black,
                                 Black,Black,Black,Black,Black,
                                 Black,Black,Black,Black,Black,
                                 Black,Black,Black,Black,Black,                        
                                 Black,Black,Black,Black,Black
                              };

                        
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   int   i;
   IndicatorShortName(ShortName);
   
   for(i=0;i<=WindowHeight;i++)   ObjectDelete(ShortName+i);     


         
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   int   i;
   
   for(i=0;i<=WindowHeight;i++)   ObjectDelete(ShortName+i);  
   
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int   i;

// get global variables   
   if(GlobalVariableCheck("DebugOn"))        UseDebug = GlobalVariableGet("DebugOn");  
   else                                      GlobalVariableSet("DebugOn",0);        
   if(GlobalVariableCheck("DebugReset"))     Reset = GlobalVariableGet("DebugReset");     
   else                                      GlobalVariableSet("DebugReset",0);      
   if(GlobalVariableCheck("DebugPeriod"))    Dperiod = GlobalVariableGet("DebugPeriod");     
   else                                      GlobalVariableSet("DebugPeriod",0);  
   if(GlobalVariableCheck("DebugSound"))     Dsound = GlobalVariableGet("DebugSound");     
   else                                      GlobalVariableSet("DebugSound",0);  
  
//   if(GlobalVariableCheck("DebugXstart"))    xStart = GlobalVariableGet("DebugXstart");     
//   else                                      GlobalVariableSet("DebugXstart",10);  
   
   if(GlobalVariableCheck("DebugUseLog"))    UseLog = GlobalVariableGet("DebugUseLog");     
   else                                      GlobalVariableSet("DebugUseLog",0);  
   if(GlobalVariableCheck("DebugTabs"))      Tabs = GlobalVariableGet("DebugTabs");     
   else                                      GlobalVariableSet("DebugTabs",0);  
   
    
   if(!UseDebug)
   {
      for(i=0;i<=WindowHeight;i++)   ObjectDelete(ShortName+i);     
      return(0);
   }

   if(Reset)
   {
      for(i=0;i<WindowHeight;i++)
      {
         DebugData[i] = "";
         DataColor[i] = Black;   
         StoreData();
         GlobalVariableSet("DebugReset",0);             
      }
      Reset = false;
   }
   else
         RestoreData();
   
/*   if(UseLog > 0)
   {         
         Log(Name+" debug log ",Info,Tabs);
   }  */
   NewData();
   if((Period() == Dperiod) || (Dperiod == 0))  
   {
         DisplayData(xStart);
   }
   else                                         
      for(i=0;i<=WindowHeight;i++)   ObjectDelete(ShortName+i);   
   StoreData();
   if(Dsound)  PlaySound("tick.wav");
   return(0);
}
//+------------------------------------------------------------------+

void DisplayData(int xStart)
{
   int   i,
         x     = 10,
         y     = 10,
         space = 15,
         ctr   = 0;

   ObjectCreate(ShortName+ColNum+ctr, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ShortName+ColNum+ctr,"DEBUG - Copyright  2009,   flexie", 10,"Times New Roman Bold Italic", DodgerBlue);
   ObjectSet(ShortName+ColNum+ctr, OBJPROP_CORNER, 2);
   ObjectSet(ShortName+ColNum+ctr, OBJPROP_XDISTANCE, 10);
   ObjectSet(ShortName+ColNum+ctr, OBJPROP_YDISTANCE, y);           
   ctr++;      
   y += 20;
   for(i=0;i<WindowHeight;i++)
   {
      ObjectDelete(ShortName+ColNum+ctr);      
      ObjectCreate(ShortName+ColNum+ctr, OBJ_LABEL, 0, 0, 0);
      ObjectSetText(ShortName+ColNum+ctr,DebugData[i], FontSize, Font, DataColor[i]);
      ObjectSet(ShortName+ColNum+ctr, OBJPROP_CORNER, 2);
      ObjectSet(ShortName+ColNum+ctr, OBJPROP_XDISTANCE, xStart);
      ObjectSet(ShortName+ColNum+ctr, OBJPROP_YDISTANCE, y);  
      ctr++;
      y += space;            
   }
}


//+------------------------------------------------------------------+
// restore data on program start
//+------------------------------------------------------------------+
int RestoreData()
{
   int   i,
         err,
         handle;
   string   fName;

   fName = StringConcatenate(ShortName,"-",Symbol(),"-",Period(),ColNum,"-data.csv");
   handle=FileOpen(fName,FILE_CSV|FILE_READ|FILE_WRITE);

   if(handle >0)  
   {
      for(i=0;i<WindowHeight;i++)      
      {
         DebugData[i] = FileReadString(handle);
         DataColor[i] = FileReadNumber(handle);
      }
   }
   else
      return(-1);
   FileClose(handle); 
   
   return(0);
}

//+------------------------------------------------------------------+
// store data on exit
//+------------------------------------------------------------------+
int StoreData()
{   
   int   i,
         err,
         handle;
   string   fName;
   
   fName = StringConcatenate(ShortName,"-",Symbol(),"-",Period(),ColNum,"-data.csv");
   handle=FileOpen(fName,FILE_CSV|FILE_READ|FILE_WRITE);
   
   for(i=0;i<WindowHeight;i++)
   {
      FileWrite(handle,DebugData[i],DataColor[i]);  
   }
   FileClose(handle); 
   return(0);
}

int NewData()
{
   int   i;
   
   for(i=WindowHeight;i>0;i--)
   {
      DebugData[i] = DebugData[i-1];
      DataColor[i] = DataColor[i-1];
   }
   DebugData[i] = TimeToStr(TimeCurrent(),TIME_MINUTES|TIME_SECONDS)+" "+Info;
   DataColor[i] = FontColor;
}

